local missingParameter = {}

STAT_CRIT_DMG=47
STAT_CRIT_DMG_MAG=46
EsoStrings[SI_DERIVEDSTATS47] ="|c66ccffWeapon Critical Damage|r"  
EsoStrings[SI_DERIVEDSTATS46] ="|c66ccffSpell Critical Damage|r"
EsoStrings[SI_DERIVEDSTATS34] ="|c66ccffSpell Penetration|r"      --STAT_SPELL_PENETRATION = 34
EsoStrings[SI_DERIVEDSTATS33] ="|c66ccffPhysical Penetration|r"         ----STAT_PHYSICAL_PENETRATION = 33


local STONE_VALUE_SHADOW=0.09  





CritD=CritD or {} 
local StrWep= "The percentage of increased damage from critically attacking an enemy (vs non-crit attacks) with physical abilities."
local StrMag= "The percentage of increased damage from critically attacking an enemy (vs non-crit attacks) with magic abilities."

ZO_CreateStringId("SI_STAT_TOOLTIP_CRIT_DMG", StrWep)
ZO_CreateStringId("SI_STAT_TOOLTIP_CRIT_DMG_MAG", StrMag)
ZO_STAT_TOOLTIP_DESCRIPTIONS[STAT_CRIT_DMG]=SI_STAT_TOOLTIP_CRIT_DMG
ZO_STAT_TOOLTIP_DESCRIPTIONS[STAT_CRIT_DMG_MAG]=SI_STAT_TOOLTIP_CRIT_DMG_MAG



CritD.Forces=
        {
            ["Major Force"]={ ["name"]="Major Force", ["value"]=15 }, 
            ["Minor Force"]={["name"]="Minor Force", ["value"]=10 }
         }    
function CritD:TheForceBeWithYou() 
   local flag=0
   local X=0
      for i=1, GetNumBuffs("player") do 
      X=select(1,GetUnitBuffInfo("player",i))
--      X= X or 0
         if self.Forces[X] ~=nil --x is the code of one of the listed stones
         then flag = flag+self.Forces[X].value   
         end
      end
   return flag   
end

function CritD.Gear(i)  
    return GetItemLinkTraitInfo(GetItemLink(BAG_WORN,i) )    -- Get(,1) = trait id (18 is div) Get(_,2) is the text of the trait 
end 
    
function CritD:Ggdivines()
    local flag=0
    local x, y=0
    local T= {0,2,3,6,7,8,9}    -- T enumerates the only slots which can have worn gear (other than weapons)
    for _,i in pairs(T) do x, y=self.Gear(i)
        if x==18     -- 18 means divines
            then flag=flag+tonumber(string.sub(y,string.find(y, "%d%.%d"))) 
        end
    end
    return flag/100 
end




function CritD:TheShadowBeWithYou(ResultType)   

   local DIV= CritD:Ggdivines()
   local Percent = 100
   ResultType= ResultType or 0 

   if ResultType == 0 
      then Percent=100 
      else Percent = 1 
   end 
   local flag=0
   local x=0

    for i=1, GetNumBuffs("player") 
        do  x=select(11,GetUnitBuffInfo("player",i))
        if x==13984 --code for shadow stone
            then flag = Percent*STONE_VALUE_SHADOW * (1+DIV)
        end
    end

   return math.floor(flag)       
end

CritD.TemplarT={};  CritD.NightbladeT={}  
   for i=1, 6 do 
      local Id= GetSkillAbilityId(1,1,i) 
      CritD.TemplarT[Id]=1 -- The table has keys equal to the templar aedric spear abilities.  Second entry not nil   
      CritD.NightbladeT[Id]=1   --- The table has keys equal to the nb ass abilities.  Second entry not nil  
   end 

function CritD:TheClassBeWithYou()
   
   local class=GetUnitClassId("player")  -- returns number in bijection with the 5 (6!) classes
   local  flag=0 
   local test=0  

 -- Assuming player has appropiate skills on bar if a nb or templar.  will edit as i learn more

   if class==3 then   -- If nb
      for i=3, 9 do 
         if self.NightbladeT[GetSlotBoundId(i)] ~= nil   -- Checks to see if one has an ass ability slotted
            then test= 1 
         end
      end    
      local a=GetSkillAbilityUpgradeInfo(1,1,10)     -- Is hem passive leveled?  
      flag=5*a*test     
   elseif class==6 then -- if Templar 
      for i=3, 9 do 
         if self.TemplarT[GetSlotBoundId(i)] ~= nil   -- Checks to see if one has an aedric spear ability 
            then test= 1 
         end
      end    
      local a=GetSkillAbilityUpgradeInfo(1,1,7)     -- Is passive leveled?  
      flag=5*a*test     
   else 
      flag =0       
   end  
        
return flag 
end    

function CritD:CritDamage(type)    -- type =1 stam, 0 mag
   local total,base =0, 50 -- Default crit damage is 50
   local P = 0
   local GCP  = 0
   local GStone=self:TheShadowBeWithYou()
   local GClass=self:TheClassBeWithYou()    
   local GBuff=self:TheForceBeWithYou()   
   
    type = type or 0.5     
        
       
  -- P=0.01*math.max(GetNumPointsSpentOnChampionSkill(5, 2),GetNumPointsSpentOnChampionSkill(7, 3))
   
   local Ps  =  GetNumPointsSpentOnChampionSkill(5, 2)  --- Points in precise strikes  
   local Pm  =  GetNumPointsSpentOnChampionSkill(7, 3)  ---- Points into elfborn  
   
   P=  0.01*(type*Ps+(1-type)*Pm)   -- So if type =1 stam build, 0 mag      
   GCP = 0.25*P*(2-P)   -- +(1-P)*(0.5-P)*P*2/250 
   GCP =math.floor(100*GCP)
   total=base  +GClass+GCP +GBuff+ GStone 
   return total
end                





    
CritD.GetGet =GetPlayerStat 



GetPlayerStat = function(stat, ...)
    local flag=0
      if stat==STAT_CRIT_DMG then flag =CritD:CritDamage(1)
      elseif stat==STAT_CRIT_DMG_MAG   then flag =CritD:CritDamage(0)
      else flag=CritD.GetGet(stat, ...)
    end 
return flag
--GetPlayerStat=GetGet  --- Not sure if this will work right .. ?
end  





--GetString = function (n)
--local flag =""    
--    if n == SI_STAT_TOOLTIP_CRIT_DMG
--    then flag = n 
--    else flag = GES.GetString(n)
--    end 
--return flag
----GetString=CritD.GetString 
--end 
    
--STAT_DESCRIPTIONS[]   

local AddStatRowOrg = ZO_Stats.AddStatRow

ZO_Stats.AddStatRow = function(...)      ---originally has two arguments.
missingParameter = (select(1,...))  --- select(1,...) seems to just return ... ?
	local ret = AddStatRowOrg(...)
	ZO_Stats.AddStatRow = AddStatRowOrg
return ret
end


local CreateAttributesSectionOrg = ZO_Stats.CreateAttributesSection

ZO_Stats.CreateAttributesSection = function(...)
	local ret = CreateAttributesSectionOrg(...)

ZO_Stats.SetNextControlPadding(missingParameter,20)   --- There's a missing parameter because functions defined as self:SetNextControlPadding, etc  
ZO_Stats.AddStatRow(missingParameter,STAT_SPELL_PENETRATION,STAT_PHYSICAL_PENETRATION)

ZO_Stats.SetNextControlPadding(missingParameter,0) 

ZO_Stats.AddStatRow(missingParameter,STAT_CRIT_DMG_MAG, STAT_CRIT_DMG)

return ret
end